      subroutine fit(n,b,c,zm1,contm,fitm)

      implicit none
      DOUBLE PRECISION :: b(0:300,0:300),c(0:300,0:300),&
                          fitm(0:300,0:300),zm1(0:300,0:300)
      INTEGER ::          n,i,j,i1,j1,contm(0:300,0:300),k3

      k3=int(0.3D0*dble(n))    !!!!! padding width

!!!!! Fit the final result by the transformtaion estimators

      do i=0,n
        do j=0,n

         i1=int((dble(i)/dble(n)+b(i,j))*dble(n))
         j1=int((dble(j)/dble(n)+c(i,j))*dble(n))

         if(i1<0) then
           if(i1+k3<0) then
             i1=k3
           else
             i1=-i1
           end if
         end if

         if(i1>n) then
           if(i1+k3>n+2*k3) then
             i1=2*n-k3
           else
             i1=2*n-i1
           end if
         end if

         if(j1<0) then
           if(j1+k3<0) then
             j1=k3
           else
             j1=-j1
           end if
         end if

         if(j1>n) then
           if(j1+k3>n+2*k3) then
             j1=2*n-k3
           else
             j1=2*n-j1
           end if
         end if

         fitm(i,j)=zm1(i1,j1)

        end do
      end do

      do i=0,n
        do j=0,n

          if(fitm(i,j)<0D0) then
            fitm(i,j)=zm1(i,j)
              if(fitm(i,j)<0D0) then
                 fitm(i,j)=0D0
              end if
          end if

        end do
      end do


      end subroutine fit

 
