      subroutine nondegeneratetype(n,num,d1,zr1,zm1,b,c,contm,contr,episilon,r_nondeg,degtyper,degtypem)

      implicit none
      DOUBLE PRECISION :: zr1(0:300,0:300),zm1(0:300,0:300),&
                          zr(0:600,0:600),zm(0:600,0:600),&
                          rss(0:300,0:300),&
                          b(0:300,0:300),c(0:300,0:300),&
                          minimum,d1,episilon,r_nondeg,episilon2
      INTEGER ::          n,k,i,j,i1,j1,i2,j2,contm(0:300,0:300),&
                          temp1,temp2,k1,rsscount,nonnegative,n1,num,&
                          temnum,k2,i3,j3,indicator(0:300,0:300),&
                          degtyper(0:300,0:300),degtypem(0:300,0:300),&
                          contr(0:300,0:300),total_n,i4,j4,k3

      k1=int(d1*dble(n))
      k=int(r_nondeg*dble(n))
      k3=int(0.3D0*dble(n))    !!!!! padding width

      episilon2=1D-16    !!!!! test against equality

      total_n=0
      do i4=-k1,k1
        do j4=-k1,k1
          if((dble(i4-0)**2D0+dble(j4-0)**2D0)<=(dble(k1)**2D0)) then
              total_n=total_n+1
          end if
        end do
      end do


!!!!! padding the boundary regions of reference image with radius 0.3

      do i=k3,k3+n
         do j=k3,k3+n
            zr(i,j)=zr1(i-k3,j-k3)
         end do
      end do

      do i=0,k3
         do j=0,k3
            zr(k3-i,k3-j)=zr(k3+i,k3+j)
         end do
      end do

      do i=k3+1,k3+n
         do j=0,k3
            zr(i,k3-j)=zr(i,k3+j)
         end do
      end do

      do i=0,k3
         do j=0,k3
            zr(k3+n+i,k3-j)=zr(k3+n-i,k3+j)
         end do
      end do

      do i=0,k3
         do j=k3+1,k3+n
            zr(k3+n+i,j)=zr(k3+n-i,j)
         end do
      end do

      do i=0,k3
         do j=0,k3
            zr(k3+n+i,k3+n+j)=zr(k3+n-i,k3+n-j)
         end do
      end do

      do i=k3+1,k3+n
         do j=0,k3
            zr(i,k3+n+j)=zr(i,k3+n-j)
         end do
      end do

      do i=0,k3
         do j=0,k3
            zr(k3-i,k3+n+j)=zr(k3+i,k3+n-j)
         end do
      end do

      do i=0,k3
         do j=k3+1,k3+n
            zr(k3-i,j)=zr(k3+i,j)
         end do
      end do


!!!!! padding the boundary regions of match image with radius 0.3

      do i=k3,k3+n
         do j=k3,k3+n
            zm(i,j)=zm1(i-k3,j-k3)
         end do
      end do

      do i=0,k3
         do j=0,k3
            zm(k3-i,k3-j)=zm(k3+i,k3+j)
         end do
      end do

      do i=k3+1,k3+n
         do j=0,k3
            zm(i,k3-j)=zm(i,k3+j)
         end do
      end do

      do i=0,k3
         do j=0,k3
            zm(k3+n+i,k3-j)=zm(k3+n-i,k3+j)
         end do
      end do

      do i=0,k3
         do j=k3+1,k3+n
            zm(k3+n+i,j)=zm(k3+n-i,j)
         end do
      end do

      do i=0,k3
         do j=0,k3
            zm(k3+n+i,k3+n+j)=zm(k3+n-i,k3+n-j)
         end do
      end do

      do i=k3+1,k3+n
         do j=0,k3
            zm(i,k3+n+j)=zm(i,k3+n-j)
         end do
      end do

      do i=0,k3
         do j=0,k3
            zm(k3-i,k3+n+j)=zm(k3+i,k3+n-j)
         end do
      end do

      do i=0,k3
         do j=k3+1,k3+n
            zm(k3-i,j)=zm(k3+i,j)
         end do
      end do


!!!!! register edge-like non-degenerate point (contr == 1):
!!!!! find a neighborhood with radius k in reference image with the same location as in matched image

      do i=k3,n+k3
        do j=k3,n+k3
         if(contr(i-k3,j-k3)==1) then


      !!!!! first find a radius to include (>= num) the same type points

!      temnum=0
!      k2=0
!      indicator=0
!      do while(temnum < num)
!          k2=k2+1
!          do i3=i-k2,i+k2
!            do j3=j-k2,j+k2
!                if(i3>=0 .and. i3<=n .and. j3>=0 .and. j3<=n .and. indicator(i3,j3)==0) then
!                    if((dble(i3-i)**2D0+dble(j3-j)**2D0)<=dble(k2)**2D0) then
!                        if(abs(zr1(i3,j3)-zm1(i3,j3)) < episilon .and. contm(i3,j3)==1) then
!                            temnum=temnum+1
!                        end if
!                        indicator(i3,j3)=1
!                    end if
!                end if
!            end do
!          end do
!      end do
!      k=k2


         rss=-1D0
         nonnegative=0
         do i1=i-k,i+k
           do j1=j-k,j+k

           if(  &
!             i1>=0 .and. i1<=n .and. j1>=0 .and. j1<=n .and. &
             (dble(i1-i)**2D0+dble(j1-j)**2D0)<=(dble(k)**2D0) &
             .and. contm(i1-k3,j1-k3)==1 &
             ) then

             n1=0
             rsscount=0  !!!! to count how many points qualify the following two if conditions inside the the i2,j2 loop
             do i2=i1-k1,i1+k1
               do j2=j1-k1,j1+k1

                if(  &
                  i2>=0 .and. i2<=n+2*k3 .and. j2>=0 .and. j2<=n+2*k3 .and. &
                  (dble(i2-i1)**2D0+dble(j2-j1)**2D0)<=(dble(k1)**2D0)) then
                    temp1=i1-i2
                    temp2=j1-j2
                    if((i-temp1)>=0 .and. (i-temp1)<=n+2*k3 .and. (j-temp2)>=0 .and. (j-temp2)<=n+2*k3) then
                       rsscount=rsscount+1
                       if(rsscount==1) then  !!!! if that is the first qualified point, then initialize rss
                          rss(i1,j1)=0D0+((zr((i-temp1),(j-temp2))-zm(i2,j2))**2D0)
                          n1=n1+1
                       else                  !!!! otherwise just add them up
                          rss(i1,j1)=rss(i1,j1)+((zr((i-temp1),(j-temp2))-zm(i2,j2))**2D0)
                          n1=n1+1
                       end if
                    end if
                end if

               end do
             end do

           end if

           if(rss(i1,j1)>0D0) then
             nonnegative=nonnegative+1
               if(nonnegative==1) then  !!!!! initialize the value of minimum and b(i,j), c(i,j)
                  minimum=rss(i1,j1)/dble(n1)
                  minimum=sqrt(dble(n1)/dble(total_n))*minimum      !!!!! normalize the minimum value
                  b(i-k3,j-k3)=dble(i1-i)/dble(n)
                  c(i-k3,j-k3)=dble(j1-j)/dble(n)
               else    !!!!! find the minimum residual sum square then get the estimated transformation vector
                  if(abs((rss(i1,j1)/dble(n1)*sqrt(dble(n1)/dble(total_n))) - minimum) < episilon2) then
                     if(i1 >= k3 .and. i1 <= n+k3 .and. j1 >= k3 .and. j1 <= n+k3) then
                         b(i-k3,j-k3)=dble(i1-i)/dble(n)
                         c(i-k3,j-k3)=dble(j1-j)/dble(n)
                         minimum=rss(i1,j1)/dble(n1)*sqrt(dble(n1)/dble(total_n))
                     end if
                  else if((rss(i1,j1)/dble(n1)*sqrt(dble(n1)/dble(total_n)))>minimum) then
                     b(i-k3,j-k3)=b(i-k3,j-k3)
                     c(i-k3,j-k3)=c(i-k3,j-k3)
                  else
                     b(i-k3,j-k3)=dble(i1-i)/dble(n)
                     c(i-k3,j-k3)=dble(j1-j)/dble(n)
                     minimum=rss(i1,j1)/dble(n1)*sqrt(dble(n1)/dble(total_n))
                  end if
               end if
           end if

           end do
         end do

         else if(degtyper(i-k3,j-k3)==1) then   !!!!! register 1D-degenerate point (degtyper == 1): same algorithm as above

         rss=-1D0
         nonnegative=0
         do i1=i-k,i+k
           do j1=j-k,j+k

           if(  &
!             i1>=0 .and. i1<=n .and. j1>=0 .and. j1<=n .and. &
             (dble(i1-i)**2D0+dble(j1-j)**2D0)<=(dble(k)**2D0) &
             .and. contm(i1-k3,j1-k3)==1 &
             ) then

             n1=0
             rsscount=0  !!!! to count how many points qualify the following two if conditions inside the the i2,j2 loop
             do i2=i1-k1,i1+k1
               do j2=j1-k1,j1+k1

                if(  &
                  i2>=0 .and. i2<=n+2*k3 .and. j2>=0 .and. j2<=n+2*k3 .and. &
                  (dble(i2-i1)**2D0+dble(j2-j1)**2D0)<=(dble(k1)**2D0)) then
                    temp1=i1-i2
                    temp2=j1-j2
                    if((i-temp1)>=0 .and. (i-temp1)<=n+2*k3 .and. (j-temp2)>=0 .and. (j-temp2)<=n+2*k3) then
                       rsscount=rsscount+1
                       if(rsscount==1) then  !!!! if that is the first qualified point, then initialize rss
                          rss(i1,j1)=0D0+((zr((i-temp1),(j-temp2))-zm(i2,j2))**2D0)
                          n1=n1+1
                       else                  !!!! otherwise just add them up
                          rss(i1,j1)=rss(i1,j1)+((zr((i-temp1),(j-temp2))-zm(i2,j2))**2D0)
                          n1=n1+1
                       end if
                    end if
                end if

               end do
             end do

           end if

           if(rss(i1,j1)>0D0) then
             nonnegative=nonnegative+1
               if(nonnegative==1) then  !!!!! initialize the value of minimum and b(i,j), c(i,j)
                  minimum=rss(i1,j1)/dble(n1)
                  minimum=sqrt(dble(n1)/dble(total_n))*minimum      !!!!! normalize the minimum value
                  b(i-k3,j-k3)=dble(i1-i)/dble(n)
                  c(i-k3,j-k3)=dble(j1-j)/dble(n)
               else    !!!!! find the minimum residual sum square then get the estimated transformation vector
                  if(abs((rss(i1,j1)/dble(n1)*sqrt(dble(n1)/dble(total_n))) - minimum) < episilon2) then
                     if(i1 >= k3 .and. i1 <= n+k3 .and. j1 >= k3 .and. j1 <= n+k3) then
                         b(i-k3,j-k3)=dble(i1-i)/dble(n)
                         c(i-k3,j-k3)=dble(j1-j)/dble(n)
                         minimum=rss(i1,j1)/dble(n1)*sqrt(dble(n1)/dble(total_n))
                     end if
                  else if((rss(i1,j1)/dble(n1)*sqrt(dble(n1)/dble(total_n)))>minimum) then
                     b(i-k3,j-k3)=b(i-k3,j-k3)
                     c(i-k3,j-k3)=c(i-k3,j-k3)
                  else
                     b(i-k3,j-k3)=dble(i1-i)/dble(n)
                     c(i-k3,j-k3)=dble(j1-j)/dble(n)
                     minimum=rss(i1,j1)/dble(n1)*sqrt(dble(n1)/dble(total_n))
                  end if
               end if
           end if

           end do
         end do


         end if

        end do
        if(mod(i,40) == 0) then
          write(*,*) i
        end if
      end do


      end subroutine nondegeneratetype


