      subroutine boundarypoint(n,boundary,b,c,contm,contr)

      implicit none
      DOUBLE PRECISION :: b(0:300,0:300),c(0:300,0:300),&
                          boundary,i1,j1
      INTEGER ::          n,k,i,j,contm(0:300,0:300),contr(0:300,0:300)

      k=int(boundary*dble(n))

!!!!! register the boundary point
!!!!! find a nearest interior point, take that transformation and if the transformation is beyond the area,
!!!!! set the transformation as 0

      do i=0,k
        do j=0,k
         if(contr(i,j)==3) then
           b(i,j)=b(k,k)
           c(i,j)=c(k,k)
         end if
        end do
      end do

      do i=n-k,n
        do j=n-k,n
         if(contr(i,j)==3) then
           b(i,j)=b(n-k,n-k)
           c(i,j)=c(n-k,n-k)
         end if
        end do
      end do

      do i=0,k
        do j=n-k,n
         if(contr(i,j)==3) then
           b(i,j)=b(k,n-k)
           c(i,j)=c(k,n-k)
         end if
        end do
      end do

      do i=n-k,n
        do j=0,k
         if(contr(i,j)==3) then
           b(i,j)=b(n-k,k)
           c(i,j)=c(n-k,k)
         end if
        end do
      end do

      do i=0,k
        do j=k,n-k
         if(contr(i,j)==3) then
           b(i,j)=b(k,j)
           c(i,j)=c(k,j)
         end if
        end do
      end do

      do i=k,n-k
        do j=n-k,n
         if(contr(i,j)==3) then
           b(i,j)=b(i,n-k)
           c(i,j)=c(i,n-k)
         end if
        end do
      end do

      do i=n-k,n
        do j=k,n-k
         if(contr(i,j)==3) then
           b(i,j)=b(n-k,j)
           c(i,j)=c(n-k,j)
         end if
        end do
      end do

      do i=k,n-k
        do j=0,k
         if(contr(i,j)==3) then
           b(i,j)=b(i,k)
           c(i,j)=c(i,k)
         end if
        end do
      end do

      do i=0,n
        do j=0,n
         if(contr(i,j)==3) then
          i1=dble(i)/dble(n)+b(i,j)
          j1=dble(j)/dble(n)+c(i,j)
          if(i1<0D0 .or. i1>1D0 .or. j1<0D0 .or. j1>1D0) then
           b(i,j)=0D0
           c(i,j)=0D0
          end if
         end if
        end do
      end do


      end subroutine boundarypoint

